# Gacha Progression (SECRET, IN DEVELOPMENT!)
![](https://i.imgur.com/5P9Cw0j.jpeg)
## GOAL: Unlock all 69 gun hats by playing TnH!
## [Tutorial VIDEO](https://www.reddit.com/r/H3VR/comments/1bs0mak/gacha_progression_trailertutorial/)

**Summary:** Modifies H3VR TnH by adding random Gun-Hat lootbox drops from killing sosigs, armor spawns in Supply Rooms, and rewards for finishing a TnH game. All rewards scale with TnH *difficulty* settings you select before playing.

Please provide feedback after reading "Known Bugs".  
[>>[Feedback form]<<](https://forms.gle/TBEe2btHePCsGp557)   

### How to Play:
1. Download this mod
2. Start playing any TNH game
3. This mod will automatically reward you with keys and cases through gameplay (explained below)  
4. You can reset hats unlock progress at any point (read below)

### Loot:
- After killing about approx. 5 Sosigs, a Sosig will drop either a KEY or a CASE
- Supply Points have a chance of spawning CASES, ARMOR, and HELMETS scaled to difficulty
- Finishing a game of TnH will award you some of 3 custom loot crates depending on TnH's difficulty {Basic, Hard, Impossible}

### Difficulty Rewards
- "Basic"
  - No difficulty modifiers
  - Supply room has SMALL armor & helmet loot
  - Awards BASIC backpack with 6 CASES and 5 KEYS on game finish
- "Hard"
  - Any of the following enable hard-rewards: **Limited Ammo**, **Human health**, **Armored Health**, **Welldone Freemeat**, **Zeke ZombieHunter**, **Flaccid Steak**, **Ricky Dicky Random**
  - Supply room has MEDIUM armor & helmet loot
  - Awards MEDIUM Weapon case with 12 CASES and 12 KEYS
- "Impossible"
  - Any of the following enable impossible-rewards: **Hardcore One Hit Health**, **Tournament Toby**
  - Supply room has BIG armor & helmet loot
  - Rewards CASES and KEYS every other kill
  - Awards HUGE Weapon Case with 36 CASES and 36 KEYS and MEDIUM Weapon case


<details>
<summary>Configurable Variables</summary>

- "Overall", "ON/OFF", true, "Enable Gacha Progression"  

- "Reward Schedule", "ON/OFF", false, "Whether to use schedules below. False=immediate reward."   
 
- "Reward Schedule", "Until Next Hat Case", 10, "Minimum Sosig kills until next hat box dropped"  

- "Reward Schedule", "Until Next Key Case", 20, "Minimum Sosig kills until next KEY dropped"  

- "Reward Schedule", "Max deviation", 2, "Maximum kills added to until-next variables above."  

- "Reward Schedule", "Supply Room Spawn Chance", 0.35f, "Chance that a box in Supply rooms spawn will spawn loot on top of it."  

- "Difficulty", "Clear Loadout on TnH Death", false, "When you die in TNH, whether we wipe what you're wearing clean."  

- "Difficulty", "(Dangerous!) Reset Hat Progression", false, "Must be manually set back to false! If true, will re-lock all your hats rewards after you open your next hat case. Must be manually set back to false! Restart game."
  
</details>

<details>
<summary>**Reset Hat Progress**</summary>

**Read instructions carefully!!!**  

If you already unlocked some hats and want to start all over, this mod lets you do so without affecting other unlocks, follow these steps **EXACTLY**!  

PART 1: "Set Mod Panel Variable to TRUE"  
1. Turn your hand & open the **Wrist-menu**
2. Click **Custom Buttons** Menu, and then click **Spawn Mod Panel** button
3. In the red panel, click **Plugins** button and search the list to find "Gacha Progression"
4. Click the "Gear" icon at the far right next to this mod's entry in the list
5. Scroll to the "Difficulty" section and find the setting called "(Dangerous!) Reset Hat Progression"
6. Set "(Dangerous!) Reset Hat Progression" value to "TRUE"  

PART 2: "Open a hat-case from Item Spawner"
1. Go to the nearest ItemSpawner (new version)
2. Go to "Tools & Toys" category
3. Find the "Gun Hats" section and enter it
4. Spawn a "Hat Case" and "Key"
5. Open the Hat case with the key

PART 3: "Restart the game"
1. Quit the game
2. Start the game again (this is needed because of Otherloader, sadly)

PART 4: "Set Mod Panel Variable to FALSE"  
1. Follow steps of PART 1 until step 5.
2. Set "(Dangerous!) Reset Hat Progression" value to "FALSE"
3. *You're now done!*  
</details>

### Known Bugs
* Go report new ones here: [>>[Feedback form]<<](https://forms.gle/TBEe2btHePCsGp557)

## Planned Features
- [✓] Basic functionalities tested
- [✓] First balance & debug
- [✓] Add armor (eventually backpacks) at supply rooms depending on difficulty
- [✓] Ability to turn-off lootbox drops completely in gameplay (Gambling Safety)
- [✓] Add collector picture frames that auto-populate all the hats you've earned
- [✓] Break down Supply room chances by category (Armor, backpack, hatbox/key)
- [_] Allow other loot mods to hook into loot pool (backpacks, armor, etc)
- [_] Port over SMEME buying station (press X to doubt)

## Versions
### 0.0.6
* Balancing:
  - Supply point loot is now broken down into classes with their own spawn % (Armor, Helmets, Hat-boxes/keys)
### 0.0.5
* New:
  - Keys will spawn confetti every 10 seconds (configurable) so you don't miss them
  - Ability to turn off lootbox drops (only spawn as reward at TNH end)
  - Added collector picture frames dependency (find them in furniture)
* Bug fixes:
  - Confetti only spawns when a NEW hat is unlocked 
* Balancing:
  - Tweaks to reward schedules
### 0.0.4
* New:
  - Added armor and helmet loot spawns in Supply Room, scale with difficulty
* Bug fixes:
  - Fixed all names of Gun Hats, previously rare ones didn't unlock properly.
  - Patrols now also count towards hat-case reward kills
  - Other broken stuff
* Balancing:
  - Balanced supply room spawn rate

### 0.0.2
* Bug fixes
  - Final reward not spawning
  - Keys not spawning at correct intervals
* Balancing & New stuff:
  - Dynamic rewards at the end of each Take
  - Final rewards additive on difficulty
  - Supply points can now spawn keys too
  - Removed unbalanced hat/key drop rates depenending on difficulty.
  - Changed some default values.
  - Get insta reward on first kill

### 0.0.1
* Can reset hat-boxes unlocks
* Hat boxes actually work outside of Cappolusium
* Spawn hat boxes and keys as loot on enemy kills
* Spawn hat loot boxes in supply rooms
* Allows customization on reward schedule for spawn box and keys
* Spawns specific reward at end of TnH Game based on difficulty
* Can clear loadout if you die in TnH (optional)
